## 8.0.6 (2021-02-03)

* Bugfix for nperiod > 1 rebased for 8.0.6 RC [PR #409 | Jason Parisi](https://bitbucket.org/gyrokinetics/gs2/pull-requests/409)
* Backport gitlab to 8.0.6 [PR #403 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/403)
* Add instructions on making a release [PR #404 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/404)
* Fix for issue #138 : Ensure correct size of dimension_names array in new diagnostics distributed field code [PR #394 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/394)
* Ensure istep used in new diagnostics is not negative. [PR #377 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/377)
* Pass `nth` rather than `ntgrid` to `leqin` [PR #372 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/372)
* Pass the value of PFUNIT_VERSION_MAJOR to the build_pfunit script [PR #351 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/351)
* [backport] Fix logic checking requested pfunit version [PR #352 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/352)
* Bugfix/fix parallel netcdf inconsistent defines [PR #341 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/341)


## 8.0.5 (2020-09-02)

* 8.0.5 RC [PR #322 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/322)
* Backport/PR 306 to 8.0.5 RC [PR #319 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/319)
* Update utils and makefiles for 8.0.5 [PR #323 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/323)
* Fix Jenkins trying to fetch more than required from submodules [PR #324 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/324)
* Bugfix/fix some valgrind warnings testsuite 8 0 5 [PR #311 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/311)
* Bugfix/fix efit aminor duplicate point skip [PR #308 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/308)
* Fix calculation of the extended domain length for cases with more than one field [PR #299 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/299)
* Fix single precision build [PR #288 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/288)


## 8.0.4 (2020-03-19)

* Update utils to 8.0.4 [PR #284 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/284)
* Update DOI for 8.0.4 [PR #283 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/283)
* Fix multiple calls to `eikcoefs` when using CHEASE equilibrium [PR #271 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/271)
* Guard against a `mod` call with a potential second argument of 0 [PR #282 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/282)
* Implement `write_eigenfunc` in new diagnostics [PR #281 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/281)
* Respect `force_maxwell_reinit` input file value [PR #255 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/255)
* Introduce python for use in testing [PR #278 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/278)
* Slightly reorder operations in calculation of `apar_m` to improve cancellation [PR #280 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/280)
* Report GitLab test runner failures [PR #279 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/279)
* Remove unused `BLUEGENEARGS` makeflag [PR #277 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/277)
* Fix dim divides logic [PR #275 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/275)
* Make sure that we always write the exit reason to file even if not built [PR #274 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/274)
* Ensure skip message is written out during tests [PR #273 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/273)
* Fix wrong energy grid dimensions in `dump_grids` [PR #258 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/258)
* Fix PETSc, SLEPc interfaces for >=3.8.0 [PR #261 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/261)
* Fix normalisations output [PR #260 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/260)
* Bug fix: Guard against repeated deallocations [PR #259 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/259)
* Try to ignore temporary files when searching for pfunit tests [PR #257 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/257)


## 8.0.3 (2020-02-07)

* 8.0.3 Release [PR #229 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/229)
* Update 8.0.3-RC latest versions of utils and Makefiles [PR #250 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/250)
* Update code exit information [PR #237 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/237)
* Rename theta_grid:eps to theta_grid:eps_trapped to distinguish this from the related theta_grid_params:eps used by the s-alpha model [PR #242 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/242)
* Update for changes in utils [PR #247 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/247)
* Reorder statements to ensure we set variables based on the input values rather than the default values [PR #244 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/244)
* Fix typo in README: "CPP Plasma" to "CCP Plasma" [PR #243 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/243)
* Append fresh exit reasons instead of overwriting [PR #241 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/241)
* Add smart default for write_nl_flux in old diagnostics [PR #240 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/240)
* Try switching netcdf source to github from unidata ftp [PR #238 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/238)
* Use exit code in job manage test [PR #204 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/204)
* Bug fix: update dump response [PR #236 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/236)
* Minor bug fix: ensures that building auxiliary programs (such as dump_response etc.) will create bin (or more strictly `$(BINDIR)` ) if it doesn’t exist. [PR #235 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/235)
* Make smart default for write_fluxes [PR #212 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/212)
* Fix Jenkins checkout due to update of plugin [PR #228 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/228)
* Add explicit targets to the generated source files [PR #180 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/180)
* Make sure we respect read-only petsc vectors [PR #166 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/166)
* Fix bug in gs2_save: restart files incorrectly tried to save and restore the last but two timestep size, resulting in potentially undefined coefficients for restarted runs. [PR #201 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/201)
* Avoid requiring SLEPC_ARCH to be set for eigensolver builds. [PR #181 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/181)
* Bug fix for fortdep: allow it to recognise abstract interface [PR #182 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/182)
* Ensure we increment nout before leaving the diagnostics routine [PR #214 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/214)
* Update doi in README [PR #165 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/165)
* Generalize the changelog generator [PR #215 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/215)
* Allow OpenMPI to oversubscribe on GitLab CI [PR #203 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/203)
* Add benchmark command to build_gs2 script [PR #155 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/155)
* Tidy makefile and remove old targets [PR #161 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/161)
* Bug fix: default to reproducible runs [PR #164 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/164)
* Bug fix: update release detection [PR #160 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/160)
* Update next to 8.0.2 [PR #159 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/159)


## 8.0.2 (2019-06-10)

* 8.0.2-RC [PR #135 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/135)
* Avoid the calculation of omega in nonlinear simulations with the new diagnostics module [PR #158 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/158)
* Prevents a large number of blank lines in the benchmark output [PR #157 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/157)
* Small tweak to avoid limitation in some ifort versions [PR #156 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/156)
* Ensure only proc0 tries to write information from overrides [PR #154 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/154)
* Make sure source code for generated overrides contains bug fix from PR #105 [PR #153 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/153)
* Add pfunit tests and documentation for leq [PR #150 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/150)
* Ensure failing tests are reported on gitlab [PR #145 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/145)
* Add pFUnit as a submodule; Run pfunit_tests on gitlab CI [PR #151 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/151)
* Remove old/unused scripts [PR #147 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/147)
* Bug fix to correctly count twist-and-shift links with shat<0 [PR #149 | Nicolas Christen](https://bitbucket.org/gyrokinetics/gs2/pull-requests/149)
* Update JFRS and Cray Makefiles [PR #146 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/146)
* Bug fix: fix geometry warnings various bugs [PR #143 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/143)
* Remove include statements where not required. [PR #144 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/144)
* Ensure the Makefile.local overrides are loaded early in parsing the Makefile. [PR #142 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/142)
* Set default values for two more inputs [PR #141 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/141)
* Bugfix: set default values of some inputs [PR #140 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/140)
* Add link to libgs2 to avoid undefined symbols [PR #139 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/139)
* Fix link for Jenkins badge in README [PR #137 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/137)
* Update CITATION.cff for 8.0.2 [PR #136 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/136)
* Update to latest version of Makefiles and utils [PR #134 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/134)
* Delete gryfx test [PR #133 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/133)
* Make generated source file match generator [PR #127 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/127)
* Remove non-optimised init_connected_bc routine and deprecate opt_init_bc [PR #129 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/129)
* Fix typo introduced by automated change [PR #130 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/130)
* Move programs to program folder [PR #128 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/128)
* Rearrange directory structure [PR #126 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/126)
* Add partial changelog for 8.0.2 [PR #125 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/125)
* Bugfix/ensure restart file includes explicit source [PR #114 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/114)
* Bugfix/port changes to init connected bc opt [PR #122 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/122)
* Enable use of pfunit 4 [PR #121 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/121)
* Improve README [PR #99 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/99)
* Remove Absoft compatibility SFX-related flags [PR #111 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/111)
* Add Jenkins tests for mac-osx [PR #117 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/117)
* Smarten up website landing page [PR #119 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/119)
* Fix bug with order of pfunit build rules [PR #110 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/110)
* Add FPPFLAGS to set cpp specific options [PR #116 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/116)
* Feature/add one step pp gitlab [PR #118 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/118)
* Bugfix/avoid calling user functions with no argument makefile [PR #115 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/115)
* Move test functions from main source to unit tests [PR #93 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/93)
* Fix address sanitizer in the coverage test [PR #113 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/113)
* Bugfix for nonlinear simulations with immediate_reset=.true. [PR #107 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/107)
* Run address sanitizer as part of Jenkins coverage tests [PR #88 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/88)
* Fix segfault which occurred when [PR #105 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/105)
* Ensure we pass MACRO_DEFS when compiling c files [PR #106 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/106)
* Report tests as skipped when TESTNORUN set [PR #101 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/101)
* Micro/add nl refactoring [PR #104 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/104)
* Tweak makefile to remove non-existent Include directories [PR #103 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/103)
* Use brackets to ensure array operation only done once [PR #102 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/102)
* Don't delete benchmark timing files in CLEANCOMMAND [PR #100 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/100)
* pFUnit tests [PR #85 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/85)
* Feature/gitlab more tests [PR #95 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/95)
* Do not vary nproc in gs2_optimization test [PR #86 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/86)
* Bugfix/job manage test more robust [PR #96 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/96)
* Update utils to include precomputing nrecv/nsend in redistributes [PR #94 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/94)
* Small tweak to avoid `make depend` generating the dependency file twice [PR #90 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/90)
* Get gitlab to build and host sourcecode documentation (built on #89) [PR #91 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/91)
* Add a benchmark for the fields_local field solve [PR #79 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/79)
* Say what the current timestep is when mentioning what we're changing it to [PR #87 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/87)
* Stop Tracking Makefile.depend [PR #75 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/75)
* Put repeated logic operation in subroutine [PR #37 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/37)
* Remove reference to unused macro USE_LE_LAYOUT [PR #81 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/81)
* Provide yaml file for use with gitlab CI [PR #71 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/71)
* Try to tidy some of the existing documentation and add placeholder text for missing entries [PR #80 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/80)
* Make job_manage available cpu time test more robust [PR #84 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/84)
* Add SCARF makefile [PR #82 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/82)
* Prettier building [PR #76 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/76)
* Update utils to latest next [PR #78 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/78)
* Add scripts for creating change logs [PR #67 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/67)
* Silence lots of warnings during make [PR #72 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/72)
* Use le_layout for collisions by default [PR #3 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/3)
* Add coverage tests [PR #73 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/73)
* Automated Jenkins testing [PR #30 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/30)


## v8.0.1 (2019-02-05)

* Add CHANGELOG.md for v8.0.1, remove README_RELEASE and STATUS files [PR #63 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/63)
* Update Makefiles and utils for v8.0.1 [PR #64 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/64)
* Add empty RELEASE file [PR #69 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/69)
* Remove explicit location from GK_SYSTEM [PR #68 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/68)
* Update CITATION.cff [PR #51 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/51)
* Add an option of build_gs2 to choose MPI procs [PR #65 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/65)
* Remove SEDSYSTEMCONFIG from Makefile [PR #66 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/66)
* Turn off expensive diagnostics by default [PR #36 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/36)
* Skip gf fields cyclone itg linear test if using too few processors [PR #60 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/60)
* Remove deprecation notice in gs2_diagnostics [PR #50 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/50)
* Adds special case to ei_coll_only handling for const_v=T [PR #55 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/55)
* Fix compile errors with Cray compilers [PR #62 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/62)
* Fix several unit_tests with Fujitsu compilers [PR #61 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/61)
* Try to mirror original diagnostic treatment of nsave [PR #58 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/58)
* Fix theta_grid test with Cray compilers [PR #59 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/59)
* Update utils to inlude file_utils bugfix [PR #56 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/56)
* Fix automagic checkout of submodules [PR #49 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/49)
* Fix text colours in test output [PR #54 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/54)
* Update 8.0.1-RC to include constant_random bugfix for fujitsu compilers [PR #52 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/52)
* Tidy up gitignore and distclean for tests [PR #53 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/53)
* Set RUN_GCOV=off as default to prevent warning with build_gs2 [PR #48 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/48)
* Fix job manage test [PR #47 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/47)
* Skip some tests when building without libraries [PR #43 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/43)
* Update test_make [PR #44 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/44)
* Add citation file format file [PR #41 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/41)
* Prevent erroneous vectorization by gfortran 7.2 [PR #40 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/40)
* Fix conflicts in next to master merge [PR #39 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/39)
* Add redistribution benchmarks [PR #10 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/10)
* Update lowflow routines to use species-dependent energy and weights. [PR #33 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/33)
* Make test skipped messages more instructive [PR #35 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/35)
* Feature makefile tidyup [PR #17 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/17)
* Skip, not fail, the gf field test if fewer than 6 procs used [PR #32 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/32)
* Make master compatible with git [PR #27 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/27)
* Automatically init all submodules on make [PR #11 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/11)
* Delete collisions tests, which are a repeat of le_grids tests [PR #25 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/25)
* Contributing docs [PR #19 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/19)
* Track test coverage with Codecov [PR #31 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/31)
* Fixed variable assignment problem for variable SEDSYSTEMCONFIG in Makefile.  addresses #26 [PR #23 | Colin Malcolm Roach](https://bitbucket.org/gyrokinetics/gs2/pull-requests/23)
* Code coverage with gcov [PR #20 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/20)
* Fixed a bug where negrid was not set in calculate_f0_arrays_tabulated. [PR #24 | George Wilkie](https://bitbucket.org/gyrokinetics/gs2/pull-requests/24)
* Increase maximum pipeline time [PR #22 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/22)
* Automated testing [PR #12 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/12)
* Fix le_grid-dependent tests [PR #9 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/9)
* Adds initial setup for using Ford documentation tool. [PR #18 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/18)
* Replace svn with git [PR #7 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/7)
* Add more patterns to gitignore [PR #16 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/16)
* Update utils submodule to current master [PR #15 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/15)
* Some README tidying [PR #14 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/14)
* Feature submodules for externals [PR #6 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/6)
* Fix dump_grids build [PR #1 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1)
* Add Gitignore [PR #13 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/13)
* Add more patterns to gitignore [PR #4 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/4)
* Remove trailing bracket that causes compile error [PR #5 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/5)
